const express = require("express");
const passport = require("passport");

const router = express.Router();

router.get("/login", passport.authenticate("auth0", {
  scope: "openid email profile"
}), (req, res) => res.redirect("/"));

router.get("/callback", (req, res, next) => {
  passport.authenticate("auth0", (err, user) => {
    if (err)
      return next(err);

    if (!user)
      return res.redirect("/login");

    req.logIn(user, (err) => {
      if (err) return next(err);
      res.redirect("/");
    });
  })(req, res, next);
});

router.get("/logout", (req, res) => {
  req.logout();

  let {AUTH0_DOMAIN, AUTH0_CLIENT_ID, BASE_URL} = process.env;
  AUTH0_DOMAIN = 'adperfect-admin.auth0.com';
  AUTH0_CLIENT_ID = 'gH6CTesvUxakYwCoFjAwmEIqR7d0e1iy';
  BASE_URL = 'http://localhost:3000';
  res.redirect(`https://${AUTH0_DOMAIN}/logout?client_id=${AUTH0_CLIENT_ID}&returnTo=${BASE_URL}`);
});

module.exports = router;
